Attribute VB_Name = "modHole"
Option Explicit

Private Type hole
    x() As Integer
    y() As Integer
    strength() As Byte
    minX As Integer
    maxX As Integer
    minY As Integer
    maxY As Integer
    centerX As Single
    centerY As Single
End Type

Public grid() As Byte
Private tagged() As Byte
Private taggedc() As Byte

Public targetX() As Integer
Public targetY() As Integer

Public hole() As hole
Public holeC() As hole
Private grid2() As Single
Private c$

Public Sub InitHoles()
    ReDim hole(0)
    ReDim hole(0).x(0)
    ReDim hole(0).y(0)
    ReDim hole(0).strength(0)
    ReDim holeC(0)
    ReDim holeC(0).x(0)
    ReDim holeC(0).y(0)
    ReDim holeC(0).strength(0)
    holeC(0).x(0) = -1
    holeC(0).y(0) = -1
    hole(0).x(0) = -1
    hole(0).y(0) = -1
    ReDim targetX(100)
    ReDim targetY(100)
    
    ReDim tagged(Form1.PicTarget.ScaleWidth, Form1.PicTarget.ScaleHeight)
    ReDim taggedc(Form1.PicTarget.ScaleWidth, Form1.PicTarget.ScaleHeight)
End Sub

Public Sub Identify(x%, y%)
    Dim prob As Double, numHole%, i%
    If tagged(x, y) Then
        'already been tagged to a hole
    Else
        If Not x = 0 Then
            prob = tagged(x - 1, y)
            If prob Then numHole = prob
        End If
        If Not y = 0 Then
            prob = tagged(x, y - 1)
            If prob Then numHole = prob
        End If
        If numHole Then
            If x > 0 And y > 0 Then
                If tagged(x, y - 1) > 0 And tagged(x - 1, y) > 0 And tagged(x - 1, y) <> tagged(x, y - 1) Then
                    Form1.PicNew.PSet (x, y), RGB(255, 255, 255)
                    Form1.LabelVerbose = "==Merging Hole " & CInt(tagged(x - 1, y)) & " to " & CInt(tagged(x, y - 1))
                    mergeHoles hole(tagged(x, y - 1)), hole(tagged(x - 1, y))
                    For i = 1 To UBound(hole(numHole).x)
                        tagged(hole(numHole).x(i), hole(numHole).y(i)) = numHole
                    Next i
                    addPointToHole hole(numHole), x, y
                    tagged(x, y) = numHole
                Else
                    Form1.PicNew.PSet (x, y), RGB(255, 0, 0)
                    addPointToHole hole(numHole), x, y
                    tagged(x, y) = numHole
                End If
            Else
                Form1.PicNew.PSet (x, y), RGB(255, 0, 0)
                addPointToHole hole(numHole), x, y
                tagged(x, y) = numHole
            End If
'            Form1.LabelVerbose = "--Adding to Hole " & numHole & " " & x & "," & y
        Else
            makeNewHole
            numHole = UBound(hole)
            Form1.PicNew.PSet (x, y), RGB(0, 255, 0)
            Form1.LabelVerbose = "=-=Made new Hole " & numHole
            addPointToHole hole(numHole), x, y
'            Form1.LabelVerbose = "--Adding to Hole " & numHole & " " & x & "," & y
            tagged(x, y) = numHole
        End If
    End If
End Sub
Public Sub makeNewHole()
    Dim hole2() As hole, i%

    ReDim hole2(UBound(hole))
    hole2 = hole
    ReDim hole(UBound(hole2) + 1)
    For i = 0 To UBound(hole2)
        hole(i) = hole2(i)
    Next i
    With hole(UBound(hole))
        ReDim .x(0)
        ReDim .y(0)
        ReDim .strength(0)
        .x(0) = -1
        .y(0) = -1
    End With
End Sub
Public Sub makeNewHoleC()
    Dim hole2() As hole, i%

    ReDim hole2(UBound(holeC))
    hole2 = holeC
    ReDim holeC(UBound(hole2) + 1)
    For i = 0 To UBound(hole2)
        holeC(i) = hole2(i)
    Next i
    With holeC(UBound(holeC))
        ReDim .x(0)
        ReDim .y(0)
        ReDim .strength(0)
        .x(0) = -1
        .y(0) = -1
    End With
End Sub
Public Sub addPointToHole(ByRef numHole As hole, ByVal x As Integer, ByVal y As Integer)
    Dim x2() As Integer, i%
    Dim y2() As Integer, Strength2() As Byte
    With numHole
        ReDim x2(UBound(.x))
        ReDim y2(UBound(.y))
        ReDim Strength2(UBound(.y))
        
        x2 = .x
        y2 = .y
        Strength2 = .strength
        
        ReDim .x(UBound(x2) + 1)
        ReDim .y(UBound(y2) + 1)
        ReDim .strength(UBound(y2) + 1)
        
        For i = 0 To UBound(x2)
            .x(i) = x2(i)
            .y(i) = y2(i)
            .strength(i) = Strength2(i)
        Next i
        
        .x(UBound(.x)) = x
        .y(UBound(.y)) = y
        .strength(UBound(.y)) = grid(x, y)
        
    End With
End Sub
Private Sub mergeHoles(ByRef hole1 As hole, ByRef hole2 As hole)
    Dim i%
    For i = 1 To UBound(hole2.x)
        addPointToHole hole1, hole2.x(i), hole2.y(i)
    Next i
    removeHole hole2
End Sub
Private Sub removeHole(ByRef hole1 As hole)
    With hole1
        ReDim .x(0)
        ReDim .y(0)
        ReDim .strength(0)
        .x(0) = -1
        .y(0) = -1
    End With
End Sub
Private Sub tidyHoles()
    Dim i%, c%
    Dim hole2() As hole
    ReDim hole2(UBound(hole))
    hole2 = hole
    For i = 0 To UBound(hole2)
        If UBound(hole2(i).x) > 0 Then c = c + 1
    Next i
    If c > 0 Then ReDim hole(c - 1)
    c = 0
    For i = 0 To UBound(hole2)
        If UBound(hole2(i).x) > 0 Then
            hole(c) = hole2(i)
            c = c + 1
        End If
    Next i
End Sub
Private Sub tidyHolesC()
    Dim i%, c%
    Dim hole2() As hole
    ReDim hole2(UBound(holeC))
    hole2 = holeC
    For i = 0 To UBound(hole2)
        If UBound(hole2(i).x) > 0 Then c = c + 1
    Next i
    If c > 0 Then ReDim holeC(c - 1)
    c = 0
    For i = 0 To UBound(hole2)
        If UBound(hole2(i).x) > 0 Then
            holeC(c) = hole2(i)
            c = c + 1
        End If
    Next i
End Sub
Private Sub processHoles()
    Dim i%
    For i = 0 To UBound(hole)
        processHole hole(i), False
    Next i
End Sub
Private Sub processHolesC()
    Dim i%
    For i = 0 To UBound(holeC)
        processHole holeC(i), True
    Next i
End Sub
Private Sub processHole(numHole As hole, gay As Boolean)
    Dim i%, totalX As Double, totalY As Double, totalStrength As Double
    With numHole
        For i = 1 To UBound(.x)
            If i = 1 Then .maxX = .x(i) Else If .x(i) > .maxX Then .maxX = .x(i)
            If i = 1 Then .minX = .x(i) Else If .x(i) < .minX Then .minX = .x(i)
            If i = 1 Then .maxY = .y(i) Else If .y(i) > .maxY Then .maxY = .y(i)
            If i = 1 Then .minY = .y(i) Else If .y(i) < .minY Then .minY = .y(i)
            If gay Then totalX = totalX + .x(i) ' * (.strength(i) / 255)
            If gay Then totalY = totalY + .y(i) ' * (.strength(i) / 255)
'            If gay Then totalStrength = totalStrength + (.strength(i) / 255)
        Next i
        If UBound(.x) > 0 Then
            If gay Then .centerX = totalX / UBound(.x)
            If gay Then .centerY = totalY / UBound(.x)
        End If
    End With
End Sub
Public Sub ManageHoles()
    Dim i%
    tidyHoles
    processHoles
    removeBadHoles
    tidyHoles
    c = ""
    For i = 0 To UBound(hole)
        findCentre i
    Next i
    Clipboard.Clear
    Clipboard.SetText c
End Sub
Public Sub ManageHolesC()
    tidyHolesC
    processHolesC
End Sub
Private Sub removeBadHoles()
    Dim i%
    For i = 0 To UBound(hole)
        If isBadHole(i) Then removeHole hole(i)
    Next i
End Sub
Private Function isBadHole(numHole) As Boolean
    With hole(numHole)
        If UBound(.x) <= 4 Then isBadHole = True:     Form1.LabelVerbose = "Removed (too small) : " & numHole
        If .maxX - .minX > 150 Then isBadHole = True: Form1.LabelVerbose = "Removed (too wide ) : " & numHole
        If .maxY - .minY > 150 Then isBadHole = True: Form1.LabelVerbose = "Removed (too tall ) : " & numHole
    End With
End Function
Public Sub drawHoles()
    Dim i%, x%, y%
    For i = 0 To UBound(holeC)
        x = holeC(i).centerX
        y = holeC(i).centerY
        Form1.PicNew.PSet (x, y), RGB(255, 255, 255) 'RGB(GetRed(Form1.Point(x, y)), GetRed(Form1.Point(x, y)), GetRed(Form1.Point(x, y)))
    Next i
    'For i = 0 To UBound(hole)
        'For x = 1 To UBound(hole(i).x)
            'Form1.PicNew.PSet (hole(i).x(x), hole(i).y(x)), RGB(0, 0, 255)
        'Next x
    'Next i
End Sub
Public Sub findCentre(numHole%)
    Dim x%, y%, i%, dist As Single, temp As Single
    Const range  As Single = 5.2
    With hole(numHole)
        ReDim grid2(.minX To .maxX, .minY To .maxY)
        For y = .minY To .maxY
            For x = .minX To .maxX
                temp = 0
                For i = 1 To UBound(.x)
                    dist = ((.x(i) - x) ^ 2 + (.y(i) - y) ^ 2) ^ 0.5 + 0.5
                    If dist < range + 1 Then
                        temp = temp + 0.5
                    ElseIf dist >= range + 1 And dist < range + 2 Then
                        temp = temp + 0.5
                    End If
                Next i
                If temp > 255 Then temp = 255
                grid2(x, y) = temp
             Next x
        Next y
        
        i = 0

        For y = .minY To .maxY
             For x = .minX To .maxX
                c = c & grid2(x, y) & vbTab
                Form1.PicNew.PSet (x, y), grid2(x, y)
                If peak(x, y) Then
                    IdentifyC x, y
                End If
            Next x
            c = c & vbCrLf
        Next y
        c = c & vbCrLf
    End With
End Sub
Private Sub drawOnGrid2(x%, y%)
    Dim sx%, sy%, i%
    sx = 1
    sy = 1
    Const Outer = 1.2
    Const Inner = 1
    Const Centre = 1
main:
    addtogrid2 x + sx * 1, y + sx * 1, Inner
    addtogrid2 x + sx * 1, y + sx * 2, Inner
    addtogrid2 x + sx * 1, y + sx * 3, Inner
    addtogrid2 x + sx * 1, y + sx * 4, Inner
    addtogrid2 x + sx * 1, y + sx * 5, Inner
    addtogrid2 x + sx * 1, y + sx * 6, Inner
    addtogrid2 x + sx * 1, y + sx * 7, Outer
    
    addtogrid2 x + sx * 2, y + sx * 1, Inner
    addtogrid2 x + sx * 2, y + sx * 2, Inner
    addtogrid2 x + sx * 2, y + sx * 3, Inner
    addtogrid2 x + sx * 2, y + sx * 4, Inner
    addtogrid2 x + sx * 2, y + sx * 5, Inner
    addtogrid2 x + sx * 2, y + sx * 6, Inner
    addtogrid2 x + sx * 2, y + sx * 7, Outer
    
    addtogrid2 x + sx * 3, y + sx * 1, Inner
    addtogrid2 x + sx * 3, y + sx * 2, Inner
    addtogrid2 x + sx * 3, y + sx * 3, Inner
    addtogrid2 x + sx * 3, y + sx * 4, Inner
    addtogrid2 x + sx * 3, y + sx * 5, Inner
    addtogrid2 x + sx * 3, y + sx * 6, Outer
    
    addtogrid2 x + sx * 4, y + sx * 1, Inner
    addtogrid2 x + sx * 4, y + sx * 2, Inner
    addtogrid2 x + sx * 4, y + sx * 3, Inner
    addtogrid2 x + sx * 4, y + sx * 4, Inner
    addtogrid2 x + sx * 4, y + sx * 5, Inner
    addtogrid2 x + sx * 4, y + sx * 6, Outer
    
    addtogrid2 x + sx * 5, y + sx * 1, Inner
    addtogrid2 x + sx * 5, y + sx * 2, Inner
    addtogrid2 x + sx * 5, y + sx * 3, Inner
    addtogrid2 x + sx * 5, y + sx * 4, Inner
    addtogrid2 x + sx * 5, y + sx * 5, Outer
    
    addtogrid2 x + sx * 6, y + sx * 1, Inner
    addtogrid2 x + sx * 6, y + sx * 2, Inner
    addtogrid2 x + sx * 6, y + sx * 3, Outer
    addtogrid2 x + sx * 6, y + sx * 4, Outer
    addtogrid2 x + sx * 6, y + sx * 5, Outer
    
    addtogrid2 x + sx * 7, y + sx * 1, Outer
    addtogrid2 x + sx * 7, y + sx * 2, Outer
    
    If sx = 1 And sy = 1 Then sx = -1: sy = 1: GoTo main
    If sx = -1 And sy = 1 Then sx = 1: sy = -1: GoTo main
    If sx = 1 And sy = -1 Then sx = -1: sy = -1: GoTo main

    For i = -6 To 6
        addtogrid2 x, y + i, Inner
        addtogrid2 x + i, y, Inner
    Next i
    
    addtogrid2 x, y, Centre
    addtogrid2 x, y + 7, Outer
    addtogrid2 x, y - 7, Outer
    addtogrid2 x + 7, y, Outer
    addtogrid2 x - 7, y, Outer
    
End Sub
Private Sub addtogrid2(x%, y%, n%)
    If x <= UBound(grid2, 1) And x >= LBound(grid2, 1) And y <= UBound(grid2, 2) And y >= LBound(grid2, 2) Then
        grid2(x, y) = grid2(x, y) + n%
    End If
End Sub
Public Function peak(x%, y%)
    peak = True
    If inGrid2(x + 1, y) Then
        If grid2(x + 1, y) > grid2(x, y) Then peak = False
    Else
        peak = False
    End If
    If inGrid2(x, y + 1) Then
        If grid2(x, y + 1) > grid2(x, y) Then peak = False
    Else
        peak = False
    End If
    If inGrid2(x, y - 1) Then
        If grid2(x, y - 1) > grid2(x, y) Then peak = False
    Else
        peak = False
    End If
    If inGrid2(x - 1, y) Then
        If grid2(x - 1, y) > grid2(x, y) Then peak = False
    Else
        peak = False
    End If
    If grid2(x, y) < 50 Then peak = False
    'If peak Then MsgBox "grid2(" & x & "," & y & ") = " & grid2(x, y)
End Function
Private Function inGrid2(x%, y%) As Boolean
    If x <= UBound(grid2, 1) And x >= LBound(grid2, 1) And y <= UBound(grid2, 2) And y >= LBound(grid2, 2) Then inGrid2 = True

End Function
Public Sub IdentifyC(x%, y%)
    Dim prob As Double, numHole%
    Form1.Cls
    If taggedc(x, y) Then
        'already been tagged to a hole
    Else
        If Not x = 0 Then
            prob = taggedc(x - 1, y)
            If prob Then numHole = prob
        End If
        If Not y = 0 Then
            prob = taggedc(x - 1, y - 1)
            If prob Then numHole = prob
        End If
        If Not y = 0 Then
            prob = taggedc(x + 1, y - 1)
            If prob Then numHole = prob
        End If
        If Not y = 0 Then
            prob = taggedc(x, y - 1)
            If prob Then numHole = prob
        End If
        'numHole = 0
        If numHole Then
            If x > 0 And y > 0 Then
                If taggedc(x, y - 1) > 0 And taggedc(x - 1, y) > 0 And taggedc(x - 1, y) <> taggedc(x, y - 1) Then
                    Form1.LabelVerbose = "><==Merging Hole " & CInt(taggedc(x - 1, y)) & " to " & CInt(taggedc(x, y - 1))
                    mergeHoles holeC(taggedc(x, y - 1)), holeC(taggedc(x - 1, y))
                End If
            End If
            Form1.LabelVerbose = "><--Adding to Hole " & numHole & " " & x & "," & y
            addPointToHole holeC(numHole), x, y
            taggedc(x, y) = numHole
        Else
            makeNewHoleC
            numHole = UBound(holeC)
            Form1.LabelVerbose = "><=-=Made new Hole " & numHole
            addPointToHole holeC(numHole), x, y
            Form1.LabelVerbose = "><--Adding to Hole " & numHole & " " & x & "," & y
            taggedc(x, y) = numHole
        End If
    End If
End Sub

